// Copyright (c) 2016, XMOS Ltd, All rights reserved

#include <xscope.h>
#include "usb.h"
#include "debug_print.h"
#include "mass_storage.h"
#include "print.h"

/* USB Endpoint Defines */
#define XUD_EP_COUNT_OUT   2    //Includes EP0 (1 out EP0 + Mass Storage data output EP)
#define XUD_EP_COUNT_IN    2    //Includes EP0 (1 in EP0 + Mass Storage data input EP)

/* xSCOPE Setup Function */
#if (USE_XSCOPE == 1)
void xscope_user_init(void) {
    xscope_register(0, 0, "", 0, "");
    xscope_config_io(XSCOPE_IO_BASIC); /* Enable fast printing over links */
}
#endif

/* Prototype for Endpoint0 function in endpoint0.xc */
void Endpoint0(chanend c_ep0_out, chanend c_ep0_in);

/* The main function runs three cores: the XUD manager, Endpoint 0, and a mass storage endpoint. An array of
   channels is used for both IN and OUT endpoints */
int main()
{
    chan c_ep_out[XUD_EP_COUNT_OUT], c_ep_in[XUD_EP_COUNT_IN];

    par
    {
        on USB_TILE: xud(c_ep_out, XUD_EP_COUNT_OUT, c_ep_in, XUD_EP_COUNT_IN,
                                null, XUD_SPEED_HS, XUD_PWR_SELF);

        on USB_TILE: Endpoint0(c_ep_out[0], c_ep_in[0]);

        on USB_TILE: massStorageClass(c_ep_out[1],c_ep_in[1],0);

    }
    return 0;
}
